VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.UserControl IRTrans 
   ClientHeight    =   450
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   435
   InvisibleAtRuntime=   -1  'True
   Picture         =   "IRTrans.ctx":0000
   ScaleHeight     =   450
   ScaleWidth      =   435
   ToolboxBitmap   =   "IRTrans.ctx":058A
   Windowless      =   -1  'True
   Begin MSWinsockLib.Winsock wsock 
      Left            =   0
      Top             =   0
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      RemotePort      =   21000
   End
End
Attribute VB_Name = "IRTrans"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Dim dataReceived() As Byte
'Dim dataRemaining() As Byte
'Dim lenRemaining As Integer
'Dim intRcvlen As Integer

Dim dataReceived() As Byte
Dim lenRemaining As Integer
Dim lenReceived As Integer
Dim intRcvlen As Integer
Dim resultCount As Integer


Dim nr As NETWORKRECV
Dim nc As NETWORKCOMMAND
Dim statBuffer As STATUSBUFFER
Dim sb() As Byte
Dim rb As REMOTEBUFFER
Dim cb As COMMANDBUFFER

Dim RemoteDB() As String
Dim CommandDB() As String


Dim conStat As Integer
Dim strServer As String

Dim lastremote As String
Dim lastcommand As String
Dim lastadress As Long

Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Event Connected()
Public Event ConnectError(msg As String, Error As Integer)
Public Event Error(msg As String, netstatus As Integer, statuslevel As Integer)
Public Event CommandReady()
Public Event Receive(remote As String, command As String, Data As String)
Public Event ReceiveAdress(remote As String, command As String, Data As String, adress As Integer)
Public Event LearnReady(remote As String, command As String)
Public Event RemoteList(count As Integer)
Public Event CommandList(count As Integer)






Private Sub UserControl_Initialize()
    wsock.RemotePort = 21000
    conStat = 0
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    ServerIP = PropBag.ReadProperty("ServerIP", "localhost")
End Sub


Private Sub UserControl_Terminate()
    If wsock.State <> sckClosed Then wsock.Close
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "ServerIP", ServerIP, "localhost"
End Sub

Public Property Get ServerIP() As String
    ServerIP = strServer
End Property

Public Property Let ServerIP(ByVal vNewValue As String)
    strServer = vNewValue
    PropertyChanged "ServerIP"
End Property

Public Sub Connect()
    If wsock.State <> sckClosed Then wsock.Close
    wsock.RemoteHost = strServer
    conStat = 0
    wsock.Connect
End Sub

Public Sub GetRemotes()
    SendRemoteCommand COMMAND_GETREMOTES, "", "", 0
End Sub

Public Property Get GetRemoteName(num As Integer) As String
    GetRemoteName = RemoteDB(num)
End Property


Public Sub GetCommands(remote As String)
    SendRemoteCommand COMMAND_GETCOMMANDS, remote, "", 0
End Sub

Public Property Get GetCommandName(num As Integer) As String
    GetCommandName = CommandDB(num)
End Property

Private Sub wsock_Connect()
    Dim id As Long
    id = 0
    SocketSendStatus id, wsock
    conStat = 1
    RaiseEvent Connected
End Sub

Private Sub wsock_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    If conStat <> -1 Then RaiseEvent ConnectError(Description, Number)
    conStat = -1
End Sub


Public Property Get ConnectionStatus() As Integer
    ConnectionStatus = conStat
End Property

Public Sub LearnIR(strRemote As String, strCommand As String, Optional intTimeout As Integer = 10000, Optional intBus As Integer = 0)
    resultCount = 3
    lastremote = strRemote
    lastcommand = strCommand
    SendRemoteCommand COMMAND_LRNREM, strRemote, "", 0
    SendRemoteCommand COMMAND_LRNLONG, "", strCommand, Asc("*") Or (intBus * 256), intTimeout
    SendRemoteCommand COMMAND_CLOSE, "", "", 0
End Sub

Public Sub LearnRAWIR(strRemote As String, strCommand As String, Optional intTimeout As Integer = 10000, Optional intBus As Integer = 0)
    resultCount = 3
    lastremote = strRemote
    lastcommand = strCommand
    SendRemoteCommand COMMAND_LRNREM, strRemote, "", 0
    SendRemoteCommand COMMAND_LRNRAW, "", strCommand, Asc("*") Or (intBus * 256), intTimeout
    SendRemoteCommand COMMAND_CLOSE, "", "", 0
End Sub


Public Sub DeleteRemoteCommand(strRemote As String, strCommand As String, lngMagic As Long)
    SendRemoteCommand COMMAND_DELETECOM, strRemote, strCommand, lngMagic
End Sub

Public Sub ReloadDB()
    SendRemoteCommand COMMAND_RELOAD, "", "", 0
End Sub


Public Sub ResendIR()
    resultCount = 0
    SendRemoteCommand COMMAND_RESEND, lastremote, lastcommand, lastadress
End Sub



Public Sub SendIR(strRemote As String, strCommand As String, Optional lngAdress As Long = 0, Optional intLED As Integer = 0, Optional intBus As Integer = 0)
    If (lngAdress And 65535) <> 0 Then lngAdress = lngAdress Or &H10000
    
    If (intBus = 255) Then
        lngAdress = lngAdress Or &H40000000
    Else
        lngAdress = lngAdress Or (intBus * (2 ^ 19))
    End If
    
    If intLED > 3 Then
        intLED = intLED - 4
        lngAdress = lngAdress Or ((intLED And 7) * 2 ^ 27) Or &H80000000
    Else
        lngAdress = lngAdress Or ((intLED And 3) * 2 ^ 17)
    End If

    lastcommand = strCommand
    lastremote = strRemote
    lastadress = lngAdress
    
    resultCount = 0
    SendRemoteCommand COMMAND_SEND, strRemote, strCommand, lngAdress
End Sub


Private Sub SendRemoteCommand(cmd As Integer, strRem As String, strCom As String, lngAdress As Long, Optional intTimeout = 0)
    nc.timeout = intTimeout
    nc.netcommand = cmd
    nc.remote = strRem
    nc.command = strCom
    nc.adress = lngAdress
    SocketSendCommand nc, wsock
End Sub


Private Sub wsock_DataArrival(ByVal bytesTotal As Long)

Dim nb() As Byte
Dim lngLen As Long
Dim i As Integer


    lngLen = bytesTotal
    
    While (lngLen > 0)
    
        If lenRemaining > 0 Then
            If lngLen >= lenRemaining Then
                ReDim nb(lenRemaining)
                ReDim sb(statBuffer.statuslen - 1)
                wsock.GetData nb, , lenRemaining
                
                lngLen = lngLen - lenRemaining
                CopyMemory sb(0), dataReceived(0), lenReceived
                CopyMemory sb(lenReceived), nb(0), lenRemaining
            Else
                ReDim nb(lngLen)
                wsock.GetData nb, , lngLen
                ReDim sb(lenReceived)
                CopyMemory sb(0), dataReceived(0), lenReceived
                ReDim dataReceived(lenReceived + lngLen)
                CopyMemory dataReceived(0), sb(0), lenReceived
                CopyMemory dataReceived(lenReceived), nb(0), lngLen
                lenRemaining = lenRemaining - lngLen
                lenReceived = lenReceived + lngLen
                Exit Sub
            End If
        Else
            ReDim sb(7)
            wsock.GetData sb, , 8
            lngLen = lngLen - 8
            CopyMemory statBuffer, sb(0), 8
            
            statBuffer.statuslen = statBuffer.statuslen - 8
            
            If statBuffer.statuslen > lngLen Then
                ReDim dataReceived(lngLen - 1)
                wsock.GetData dataReceived, , lngLen
                lenReceived = lngLen
                lenRemaining = statBuffer.statuslen - lngLen
                Exit Sub
            End If
        End If
        
        resultCount = resultCount - 1
        If statBuffer.statuslen = 0 Then
            If resultCount = 1 Then
                RaiseEvent LearnReady(lastremote, lastcommand)
            Else
                RaiseEvent CommandReady
            End If
        Else
            
            If lenRemaining = 0 Then
                ReDim sb(statBuffer.statuslen - 1)
                wsock.GetData sb, , statBuffer.statuslen
                lngLen = lngLen - statBuffer.statuslen
            Else
                lenRemaining = 0
            End If
    
            If statBuffer.statustype = STATUS_MESSAGE Then
                CopyMemory ns, sb(0), statBuffer.statuslen
                    
                RaiseEvent Error(ns.message, ns.netstatus, ns.statuslevel)
            End If
            
            If statBuffer.statustype = STATUS_RECEIVE Then
                CopyMemory nr, sb(0), statBuffer.statuslen
                RaiseEvent Receive(Trim(nr.remote), Trim(nr.command), Trim(nr.Data))
                RaiseEvent ReceiveAdress(Trim(nr.remote), Trim(nr.command), Trim(nr.Data), nr.adress)
            End If
            
            If statBuffer.statustype = STATUS_REMOTELIST Then
                CopyMemory rb, sb(0), statBuffer.statuslen
                If rb.offset = 0 Then
                    ReDim RemoteDB(rb.count_total)
                End If
                For i = 0 To rb.count_buffer - 1
                    RemoteDB(rb.offset + i) = rb.remotes(i).name
                Next i
                If rb.count_remaining <> 0 Then
                    SendRemoteCommand COMMAND_GETREMOTES, "", "", rb.offset + rb.count_buffer
                Else
                    RaiseEvent RemoteList(rb.count_total)
                End If
            End If
    
            If statBuffer.statustype = STATUS_COMMANDLIST Then
                CopyMemory cb, sb(0), statBuffer.statuslen
                If cb.offset = 0 Then
                    ReDim CommandDB(cb.count_total)
                End If
                For i = 0 To cb.count_buffer - 1
                    CommandDB(cb.offset + i) = cb.commands(i)
                Next i
                If cb.count_remaining <> 0 Then
                    SendRemoteCommand COMMAND_GETCOMMANDS, "", "", cb.offset + cb.count_buffer
                Else
                    RaiseEvent CommandList(cb.count_total)
                End If
            End If
        End If

    Wend
End Sub


Public Property Get version() As Variant
    version = App.Major & "." & App.Minor & "." & App.Revision
End Property


Public Sub IRClose()
    wsock.Close
    conStat = 0
End Sub


