VERSION 5.00
Object = "{DBE405A6-41A7-4D69-9D6F-F0513DC406FC}#1.0#0"; "IRTrans.ocx"
Begin VB.Form IRTest 
   Caption         =   "Form1"
   ClientHeight    =   4095
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   4095
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdReload 
      Caption         =   "Reload DB"
      Height          =   315
      Left            =   3240
      TabIndex        =   10
      Top             =   2580
      Width           =   1035
   End
   Begin VB.CommandButton cmdDelete 
      Caption         =   "Delete Com"
      Height          =   315
      Left            =   3240
      TabIndex        =   9
      Top             =   1140
      Width           =   1035
   End
   Begin VB.ComboBox cmbCommands 
      Height          =   315
      Left            =   300
      Style           =   2  'Dropdown-Liste
      TabIndex        =   8
      Top             =   3180
      Width           =   2475
   End
   Begin VB.ComboBox cmbRemotes 
      Height          =   315
      Left            =   300
      Style           =   2  'Dropdown-Liste
      TabIndex        =   7
      Top             =   2640
      Width           =   2475
   End
   Begin VB.CommandButton cmdLearn 
      Caption         =   "Learn"
      Height          =   315
      Left            =   3240
      TabIndex        =   5
      Top             =   2100
      Width           =   1035
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "Send"
      Height          =   315
      Left            =   3240
      TabIndex        =   4
      Top             =   1620
      Width           =   1035
   End
   Begin VB.TextBox command 
      Height          =   315
      Left            =   1620
      TabIndex        =   3
      Top             =   1800
      Width           =   1155
   End
   Begin VB.TextBox remote 
      Height          =   315
      Left            =   240
      TabIndex        =   2
      Top             =   1800
      Width           =   1155
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Connect"
      Height          =   375
      Left            =   3180
      TabIndex        =   1
      Top             =   240
      Width           =   1095
   End
   Begin VB.TextBox Text1 
      Height          =   315
      Left            =   900
      TabIndex        =   0
      Text            =   "localhost"
      Top             =   240
      Width           =   1875
   End
   Begin IRTransOCX.IRTrans IRTrans1 
      Left            =   180
      Top             =   180
      _ExtentX        =   873
      _ExtentY        =   661
      ServerIP        =   ""
   End
   Begin VB.Label lblVer 
      Height          =   315
      Left            =   300
      TabIndex        =   6
      Top             =   960
      Width           =   1815
   End
End
Attribute VB_Name = "IRTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False


Private Sub cmbRemotes_Click()
    IRTrans1.GetCommands (cmbRemotes.Text)
End Sub

Private Sub cmdDelete_Click()
    IRTrans1.DeleteRemoteCommand remote, command, 1234
End Sub

Private Sub cmdLearn_Click()
    IRTrans1.LearnIR remote, command
End Sub

Private Sub cmdReload_Click()
    IRTrans1.ReloadDB
End Sub

Private Sub cmdSend_Click()
    IRTrans1.SendIR remote, command, 0, 5
End Sub


Private Sub Command1_Click()
    IRTrans1.ServerIP = Text1.Text
    IRTrans1.Connect
End Sub

Private Sub Command2_Click()
    IRTrans1.ResendIR
End Sub

Private Sub Form_Load()
    lblVer = IRTrans1.Version
End Sub



Private Sub IRTrans1_CommandReady()
'    MsgBox "Done"
End Sub

Private Sub IRTrans1_Connected()
'    MsgBox "Connected"
    
    IRTrans1.GetRemotes
End Sub

Private Sub IRTrans1_RemoteList(count As Integer)
    Dim i As Integer
    
    cmbRemotes.Clear
    For i = 0 To count - 1
        cmbRemotes.AddItem IRTrans1.GetRemoteName(i)
    Next i
End Sub

Private Sub IRTrans1_CommandList(count As Integer)
    Dim i As Integer
    
    cmbCommands.Clear
    For i = 0 To count - 1
        cmbCommands.AddItem IRTrans1.GetCommandName(i)
    Next i
    

End Sub


Private Sub IRTrans1_ConnectError(msg As String, Error As Integer)
    MsgBox msg & " [" & Error & "]"
End Sub


Private Sub IRTrans1_Error(msg As String, netstatus As Integer, statuslevel As Integer)
    MsgBox msg
End Sub

Private Sub IRTrans1_LearnReady(remote As String, command As String)
    MsgBox remote & "." & command & " Learned"
End Sub

Private Sub IRTrans1_Receive(remote As String, command As String, Data As String)
    MsgBox remote & "." & command & " [" & Data & "]"
End Sub

